]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- updated
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
10d92f71 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
cd445739 20
f8e50be5 21# Notes (todo/bugs):
f8e50be5
ER
22# - when Icon: field is present, -5 and -a5 doesn't work
23# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
19aa2571 24# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
f8e50be5
ER
25# TODO:
26# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
1ffcdaff
ER
27# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
28# Source10: forwardfix.pl
29# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
6ca6f876
ZU
30# - builder --help:
31# basename: missing operand
32# Try `basename --help' for more information.
33# -- and the normal usage info --
34
9d99a240
ER
35PROGRAM=${0##*/}
36APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
37RCSID='$Id$' r=${RCSID#* * } rev=${r%% *}
b0f031e7 38VERSION="v0.35/$rev"
d43959a2 39VERSIONSTRING="\
c9acaed9 40Build package utility from PLD Linux CVS repository
10d92f71 41$VERSION (C) 1999-2010 Free Penguins".
d43959a2 42
d6a77ddb 43PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 44
b7cc0c94
ER
45# required rpm-build-macros
46RPM_MACROS_VER=1.534
47
cd445739 48COMMAND="build"
64ea5308 49TARGET=""
cd445739 50
bde1c404 51SPECFILE=""
d287305c 52BE_VERBOSE=""
4003ad8c 53QUIET=""
cd445739
AM
54CLEAN=""
55DEBUG=""
56NOURLS=""
57NOCVS=""
58NOCVSSPEC=""
59NODIST=""
47761337 60NOINIT=""
bc10f694 61PREFMIRRORS=""
cd445739 62UPDATE=""
cd445739
AM
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 66CVSROOT=""
cdbd30e8 67GREEDSRC=""
cd445739 68
6c1b2e7d
PZ
69# use rpm 4.4.6+ digest format instead of comments if non-zero
70USEDIGEST=
71
e3aa6f5e
ER
72# user agent when fetching files
73USER_AGENT="PLD/Builder($VERSION)"
74
cd445739
AM
75# It can be used i.e. in log file naming.
76# See LOGFILE example.
77DATE=`date +%Y-%m-%d_%H-%M-%S`
78
79# Example: LOGFILE='../log.$PACKAGE_NAME'
80# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
d280fd97 81# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
f5687002 82# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
cd445739
AM
83# Yes, you can use variable name! Note _single_ quotes!
84LOGFILE=''
85
86LOGDIR=""
87LOGDIROK=""
88LOGDIRFAIL=""
89LASTLOG_FILE=""
90
91CHMOD="no"
1da227e8 92CHMOD_MODE="0644"
cd445739 93RPMOPTS=""
d1c5a9a7 94RPMBUILDOPTS=""
cd445739
AM
95BCOND=""
96GROUP_BCONDS="no"
ccffa567
ER
97
98# create symlinks for tools in PACKAGE_DIR, see get_spec()
2dd0af86 99SYMLINK_TOOLS="no"
d287305c 100
101PATCHES=""
102SOURCES=""
cd445739 103ICONS=""
d287305c 104PACKAGE_RELEASE=""
105PACKAGE_VERSION=""
106PACKAGE_NAME=""
14bead22 107ASSUMED_NAME=""
fd71d65c 108PROTOCOL="http"
cd445739 109WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 110
db5831da 111CVS_COMMAND=${CVS_COMMAND:-cvs}
939f2c12 112CVS_FORCE=""
f123bcb5 113CVSIGNORE_DF="yes"
939f2c12
ER
114CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
115CVS_SERVER="cvs.pld-linux.org"
cd445739 116CVSTAG=""
939f2c12 117
cd445739
AM
118RES_FILE=""
119
cd445739 120DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 121ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 122
36d03934 123DEF_NICE_LEVEL=19
86aafdbe 124SCHEDTOOL="auto"
cd445739
AM
125
126FAIL_IF_NO_SOURCES="yes"
127
18e5347d
ER
128# let get_files skip over files which are present to get those damn files fetched
129SKIP_EXISTING_FILES="no"
130
975d7b23 131TRY_UPGRADE=""
257af81b
ER
132# should the specfile be restored if upgrade failed?
133REVERT_BROKEN_UPGRADE="yes"
134
90baf90b
ER
135if rpm --specsrpm 2>/dev/null; then
136 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 137 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
138else
139 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
140 if [ -x /usr/bin/rpm-getdeps ]; then
141 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
142 else
143 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
144 fi
ab4a2b6e
ER
145fi
146
90baf90b 147
cd445739
AM
148# Here we load saved user environment used to
149# predefine options set above, or passed to builder
150# in command line.
151# This one reads global system environment settings:
152if [ -f ~/etc/builderrc ]; then
153 . ~/etc/builderrc
154fi
155# And this one cascades settings using user personal
156# builder settings.
157# Example of ~/.builderrc:
158#
159#UPDATE_POLDEK_INDEXES="yes"
160#FETCH_BUILD_REQUIRES="yes"
161#REMOVE_BUILD_REQUIRES="force"
162#GROUP_BCONDS="yes"
163#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 164#TITLECHANGE=no
cd445739 165#
a83e5405 166SU_SUDO=""
cd445739
AM
167if [ -n "$HOME_ETC" ]; then
168 USER_CFG="$HOME_ETC/.builderrc"
20117088 169 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
170else
171 USER_CFG=~/.builderrc
20117088 172 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
173fi
174
175[ -f "$USER_CFG" ] && . "$USER_CFG"
176
86aafdbe
ER
177if [ "$SCHEDTOOL" = "auto" ]; then
178 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
179 SCHEDTOOL="schedtool -B -e"
180 else
181 SCHEDTOOL="no"
182 fi
183fi
184
ca2e6c31 185if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
186 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
187 GETURI2="$GETURI"
188 OUTFILEOPT="-O"
ca2e6c31 189elif [ -n "$USE_AXEL" ]; then
cede92b3 190 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
191 GETURI2="$GETURI"
192 OUTFILEOPT="-o"
ca2e6c31 193else
5700ee32
ER
194 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
195 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
196 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 197 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 198
7e365483
KK
199 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
200 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
201 OUTFILEOPT="-O"
2bc5451f 202fi
11468b23 203
11468b23
AM
204GETLOCAL="cp -a"
205
206if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
207 RPM="rpm"
208 RPMBUILD="rpm"
209else
210 RPM="rpm"
211 RPMBUILD="rpmbuild"
212fi
213
c86939e2 214#
215# sanity checks
216#
217if [ -d $HOME/rpm/SOURCES ]; then
218 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
219 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
220 exit 1
221fi
222
28c23a72
AG
223#
224# are we using cvs-nserver ?
225#
e21039da 226CVS_NSERVER=0
939f2c12 227$CVS_COMMAND --version 2>&1 | grep -q 'CVS-nserver'
e21039da 228[ $? -eq 0 ] && CVS_NSERVER=1
28c23a72 229
a8c9a155 230POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 231POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 232
f6711e2a 233run_poldek() {
525bf240 234 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
cd445739
AM
235 if [ -n "$LOGFILE" ]; then
236 LOG=`eval echo $LOGFILE`
237 if [ -n "$LASTLOG_FILE" ]; then
238 echo "LASTLOG=$LOG" > $LASTLOG_FILE
239 fi
86aafdbe 240 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
241 return $exit_pldk
242 else
86aafdbe 243 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
244 return `cat ${RES_FILE}`
245 rm -rf ${RES_FILE}
246 fi
247}
248
cd445739
AM
249#---------------------------------------------
250# functions
da946cd6 251
f6711e2a 252usage() {
cd445739
AM
253 if [ -n "$DEBUG" ]; then set -xv; fi
254 echo "\
db9fdf51 255Usage: builder [-D|--debug] [-V|--version] [--short-version] [--as_anon] [-a|--add_cvs] [-b|-ba|--build]
6594293d 256[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 257[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
fd71d65c 258[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
19dc5591 259[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 260[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
f8dba812 261[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
6594293d 262[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 263[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 264<package>[.spec][:cvstag]
2a5f078d 265
cd445739
AM
266-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
267-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
268-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
269-D, --debug - enable builder script debugging mode,
270-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
271-V, --version - output builder version string
272--short-version - output builder short version
db9fdf51
ER
273--as_anon - get files via pserver as cvs@$CVS_SERVER,
274-a, --add_cvs - try add new package to CVS.
cd445739
AM
275-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
276 from <package>.spec,
277-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
278 only package from <package>.spec,
c56807e0 279-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
280-bc - execute the %build phase of <package>.spec,
281-bi - execute the %install phase of <package>.spec
282-bl - execute the %files phase of <package>.spec
cd445739
AM
283-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
284 them into src.rpm,
6594293d 285--short-circuit - short-circuit build
cd445739 286-B, --branch - add branch
387eaf99
ER
287-c, --clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
288 may be used with building process.
6f10b394
ER
289-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
290 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
291 any rpm building.
39dcc7de 292-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 293-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
294 - setup \$CVSROOT,
295--define <macro> <value>
296 - define a macro <macro> with value <value>,
44058243
ER
297--alt_kernel <kernel>
298 - same as --define 'alt_kernel <kernel>'
cd445739
AM
299--nodeps - rpm won't check any dependences
300-g, --get - get <package>.spec and all related files from CVS repo
301 or HTTP/FTP,
302-h, --help - this message,
6c5362e5 303-jN, -j N - set %_smp_mflags to propagate concurrent jobs
fd71d65c 304--ftp, --http - use ftp or http protocol to access distfiles server
cd445739
AM
305-l <logfile>, --logtofile <logfile>
306 - log all to file,
cd445739
AM
307-nc, --no-cvs - don't download sources from CVS, if source URL is given,
308-ncs, --no-cvs-specs
309 - don't check specs in CVS
310-nd, --no-distfiles - don't download from distfiles
311-nm, --no-mirrors - don't download from mirror, if source URL is given,
312-nu, --no-urls - don't try to download from FTP/HTTP location,
7cbc2d88 313-ns, --no-srcs - don't download Sources/Patches
cd445739
AM
314-ns0, --no-source0 - don't download Source0
315-nn, --no-net - don't download anything from the net
a93e8cdf 316-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
b572253e 317--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
318-ske,
319--skip-existing-files - skip existing files in get_files
cd445739
AM
320--opts <rpm opts> - additional options for rpm
321-q, --quiet - be quiet,
322--date yyyy-mm-dd - build package using resources from specified CVS date,
323-r <cvstag>, --cvstag <cvstag>
324 - build package using resources from specified CVS tag,
5323fffd 325-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
326-R, --fetch-build-requires
327 - fetch what is BuildRequired,
328-RB, --remove-build-requires
329 - remove all you fetched with -R or --fetch-build-requires
330 remember, this option requires confirmation,
331-FRB, --force-remove-build-requires
332 - remove all you fetched with -R or --fetch-build-requires
333 remember, this option works without confirmation,
06541433
JR
334-sd, --source-distfiles - list sources available from distfiles (intended for offline
335 operations; does not work when Icon field is present
336 but icon file is absent),
e15852ab 337-sc, --source-cvs - list sources available from CVS
06541433
JR
338-sdp, --source-distfiles-paths - list sources available from distfiles -
339 paths relative to distfiles directory (intended for offline
340 operations; does not work when Icon field is present
341 but icon file is absent),
a7eefc54 342-sf, --source-files - list sources - bare filenames (intended for offline
343 operations; does not work when Icon field is present
3621e588 344 but icon file is absent),
8bd5e66d 345-lsp, --source-paths - list sources - filenames with full local paths (intended for
a7eefc54 346 offline operations; does not work when Icon field is present
3621e588 347 but icon file is absent),
2dddf439
ER
348-su, --source-urls - list urls - urls to sources and patches
349 intended for copying urls with spec with lots of macros in urls
cd445739
AM
350-T <cvstag> , --tag <cvstag>
351 - add cvs tag <cvstag> for files,
352-Tvs, --tag-version-stable
094bd95b 353 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
354-Ts, --tag-stable
355 - add cvs tag STABLE for files,
cd445739 356-Tv, --tag-version
1691a37b 357 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
358-Tp, --tag-prefix <prefix>
359 - add <prefix> to NAME-VERSION-RELEASE tags,
360-tt, --test-tag <prefix>
361 - fail if tag is already present,
50321881
JK
362-ir, --integer-release-only
363 - allow only integer and snapshot releases
cd445739
AM
364-v, --verbose - be verbose,
365-u, --try-upgrade - check version, and try to upgrade package
366-un, --try-upgrade-with-float-version
367 - as above, but allow float version
0907f1eb
ER
368 php-pear-Services_Digg/
369--upgrade-version - upgrade to specified version in try-upgrade
f8dba812 370--use-greed-sources
371 - try download source from tag head if don't find it in
f5141bbc 372 current tag
deccc50e 373-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
374-Upi, --update-poldek-indexes
375 - refresh or make poldek package index files.
8bd5e66d
ER
376-sp, --skip-patch <patchnumber>
377 - don't apply <patchnumber>. may be repeated.
c890b916 378-np, --nopatch <patchnumber>
8bd5e66d 379 - abort instead of applying patch <patchnumber>
dfe2cb9a
MK
380--show-bconds - show available conditional builds, which can be used
381 - with --with and/or --without switches.
9b78be50
ER
382--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
383 ./repackage.sh script. in other words, the output is
384 parseable by scripts.
24a97174 385--show-avail-bconds - show available bconds
cd445739
AM
386--with/--without <feature>
387 - conditional build package depending on %_with_<feature>/
388 %_without_<feature> macro switch. You may now use
389 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
390 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 391--target <platform>, --target=<platform>
3621e588
ER
392 - build for platform <platform>.
393--init-rpm-dir - initialize ~/rpm directory structure
5a491465 394"
395}
396
31d2bd0b
ER
397# change dependency to specname
398# common changes:
399# - perl(Package::Name) -> perl-Package-Name
400depspecname() {
401 local package="$1"
402
560c4b1a 403 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
31d2bd0b
ER
404 echo "$package"
405}
406
c890b916 407update_shell_title() {
a0d6396b 408 [ -t 1 ] || return
0b65d15e 409 local len=${COLUMNS:-80}
5c795f16 410 local msg="$(echo "$*" | cut -c-$len)"
0b65d15e 411
e225de91
ER
412 if [ -n "$BE_VERBOSE" ]; then
413 echo >&2 "$(date +%s.%N) $*"
414 fi
415
5c795f16 416 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
138bbc98
ER
417 local pkg
418 if [ -n "$PACKAGE_NAME" ]; then
419 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
420 else
421 pkg=${SPECFILE}
422 fi
423
424 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 425 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
426 case "$TERM" in
427 cygwin|xterm*)
428 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
429 ;;
430 screen*)
431 echo >&2 -ne "\033]0;$msg\007"
432 ;;
433 esac
434 fi
c890b916
ER
435}
436
7e40520f
ER
437# set TARGET from BuildArch: from SPECFILE
438set_spec_target() {
ce40491a 439 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
b45a3b2a 440 tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
ce40491a 441 if [ "$tmp" ]; then
f9109a96 442 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
443 TARGET="$tmp"
444 case "$RPMBUILD" in
445 "rpmbuild")
f9109a96 446 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 447 "rpm")
ce40491a 448 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 449 esac
ce40491a
ER
450 fi
451 fi
7e40520f
ER
452}
453
ace3fd80
ER
454# runs rpm with minimal macroset
455minirpm() {
fa4bf1df 456 # we reset macros not to contain macros.build as all the %() macros are
559d511f 457 # executed here, while none of them are actually needed.
559d511f 458 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 459 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
460
461 # TODO: move these to /usr/lib/rpm/macros
20117088 462 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 463%x8664 x86_64 amd64 ia32e
f78a0bb7 464%alt_kernel %{nil}
465%_alt_kernel %{nil}
5ff15c97 466%bootstrap_release() %{1}
407b204b
ER
467%requires_releq_kernel_up(s:n:) %{nil}
468%requires_releq_kernel_smp(s:n:) %{nil}
469%requires_releq_kernel(s:n:) %{nil}
6b8134e3 470%requires_releq() %{nil}
bb01dee9 471%pyrequires_eq() %{nil}
559d511f 472%requires_eq() %{nil}
c13be3d1 473%requires_eq_to() %{nil}
99c05e13 474%requires_ge() %{nil}
500b0eb8
ER
475%requires_ge_to() %{nil}
476%requires_ge() %{nil}
407b204b
ER
477%releq_kernel_up(n:) ERROR
478%releq_kernel_smp(n:) ERROR
479%releq_kernel(n:) ERROR
74d9fd14 480%kgcc_package ERROR
237bd3f1 481%_fontsdir ERROR
7141278d 482%ruby_version ERROR
483%ruby_ver_requires_eq() %{nil}
484%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 485%__php_api_requires() %{nil}
7141278d 486%php_major_version ERROR
487%php_api_version ERROR
99f819cf
AM
488%requires_xorg_xserver_extension %{nil}
489%requires_xorg_xserver_xinput %{nil}
490%requires_xorg_xserver_font %{nil}
491%requires_xorg_xserver_videodrv %{nil}
7141278d 492%py_ver ERROR
41035426
ER
493%perl_vendorarch ERROR
494%perl_vendorlib ERROR
703ae20b
ER
495# damn. need it here! - copied from /usr/lib/rpm/macros.build
496%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
497%patchset_source(f:b:) %(
498 base=%{-b*}%{!-b*:10000};
499 start=$(expr $base + %1);
500 end=$(expr $base + %{?2}%{!?2:%{1}});
501 # we need to call seq twice as it doesn't allow two formats
502 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
503 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
504 paste %{tmpdir}/__ps{1,2};
505 rm -f %{tmpdir}/__ps{1,2};
506) \
507%{nil}
991f09a5
ER
508%add_etc_shells(p) %{p:<lua>}
509%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
510%lua_add_etc_shells() %{nil}
511%lua_remove_etc_shells() %{nil}
0ca65fa4
JK
512%required_jdk %{nil}
513%buildrequires_jdk %{nil}
f9063abe 514%pear_package_print_optionalpackages %{nil}
fb198857 515EOF
3d12d055 516 if [ "$NOINIT" = "yes" ] ; then
20117088 517 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
518%_specdir ./
519%_sourcedir ./
520EOF
c039643c 521 fi
fff1b991 522 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
523}
524
525cache_rpm_dump() {
526 if [ -n "$DEBUG" ]; then
527 set -x
528 set -v
529 fi
530
d1d24c14 531 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 532 update_shell_title "cache_rpm_dump using rpm-specdump command"
fff1b991 533 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
d1d24c14 534 else
525bf240 535 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
536 local rpm_dump
537 rpm_dump=`
538 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
539 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
540 case "$RPMBUILD" in
541 rpm)
542 ARGS='-bp'
543 ;;
544 rpmbuild)
545 ARGS='--nodigest --nosignature --nobuild'
546 ;;
547 esac
548 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
549 `
550 if [ $? -gt 0 ]; then
551 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
552 echo "$error" >&2
553 Exit_error err_build_fail
554 fi
d05e8080 555
d1d24c14
ER
556 # make small dump cache
557 rpm_dump_cache=`echo "$rpm_dump" | awk '
558 $2 ~ /^SOURCEURL/ {print}
559 $2 ~ /^PATCHURL/ {print}
560 $2 ~ /^nosource/ {print}
561 $2 ~ /^PACKAGE_/ {print}
562 '`
563 fi
d05e8080 564
13974367 565 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
566}
567
ace3fd80 568rpm_dump() {
cd445739 569 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 570 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
571 fi
572 echo "$rpm_dump_cache"
573}
574
f6711e2a 575get_icons() {
d05e8080 576 update_shell_title "get icons"
9d99a240 577 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
d05e8080
ER
578 if [ -z "$ICONS" ]; then
579 return
580 fi
581
975d7b23 582 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
583}
584
f6711e2a 585parse_spec() {
af4d5315 586 update_shell_title "parsing specfile"
cd445739 587 if [ -n "$DEBUG" ]; then
518ff1fb
ER
588 set -x
589 set -v
cd445739 590 fi
b2975fc3 591
d05e8080 592 # icons are needed for successful spec parse
518ff1fb 593 get_icons
d05e8080 594
9c909460 595 cd $PACKAGE_DIR
cd445739 596 cache_rpm_dump
00fcec7e 597
cd445739
AM
598 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
599 FAIL_IF_NO_SOURCES="no"
600 fi
601
7cbc2d88
ER
602 if [ "$NOSRCS" != "yes" ]; then
603 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
604 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
605 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
606 fi
607
dfe2b2d9
ER
608 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
609 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
610 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 611
0b4119a2 612 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 613 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
614 fi
615
cd445739
AM
616 if [ -n "$BE_VERBOSE" ]; then
617 echo "- Sources : `nourl $SOURCES`"
618 if [ -n "$PATCHES" ]; then
619 echo "- Patches : `nourl $PATCHES`"
620 else
621 echo "- Patches : *no patches needed*"
622 fi
623 if [ -n "$ICONS" ]; then
624 echo "- Icon : `nourl $ICONS`"
625 else
626 echo "- Icon : *no package icon*"
627 fi
628 echo "- Name : $PACKAGE_NAME"
629 echo "- Version : $PACKAGE_VERSION"
630 echo "- Release : $PACKAGE_RELEASE"
631 fi
13974367
ER
632
633 update_shell_title "parse_spec: OK!"
cd445739
AM
634}
635
f6711e2a 636Exit_error() {
cd445739 637 if [ -n "$DEBUG" ]; then
518ff1fb
ER
638 set -x
639 set -v
cd445739
AM
640 fi
641
642 cd "$__PWD"
643
644 case "$1" in
645 "err_no_spec_in_cmdl" )
646 remove_build_requires
45e2a818 647 echo >&2 "ERROR: spec file name not specified."
cd445739 648 exit 2 ;;
a08d92fc 649 "err_invalid_cmdline" )
45e2a818 650 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 651 exit 2 ;;
cd445739
AM
652 "err_no_spec_in_repo" )
653 remove_build_requires
45e2a818 654 echo >&2 "Error: spec file not stored in CVS repo."
cd445739
AM
655 exit 3 ;;
656 "err_no_source_in_repo" )
657 remove_build_requires
45e2a818 658 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739 659 exit 4 ;;
703b6deb
ER
660 "err_cvs_add_failed" )
661 echo >&2 "Error: failed to add package to CVS repo."
662 exit 4 ;;
cd445739
AM
663 "err_build_fail" )
664 remove_build_requires
45e2a818 665 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 666 exit 5 ;;
78eab2a1
AM
667 "err_no_package_data" )
668 remove_build_requires
45e2a818 669 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 670 exit 6 ;;
ce40491a 671 "err_tag_exists" )
50321881 672 remove_build_requires
45e2a818 673 echo >&2 "Tag ${2} already exists (spec release: ${3})."
50321881 674 exit 9 ;;
ce40491a 675 "err_fract_rel" )
50321881 676 remove_build_requires
45e2a818 677 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 678 exit 10 ;;
fb96e0b5
AM
679 "err_branch_exists" )
680 remove_build_requires
45e2a818 681 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 682 exit 11 ;;
cfc497c0
ER
683 "err_acl_deny" )
684 remove_build_requires
45e2a818 685 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 686 exit 12 ;;
cd445739 687 esac
45e2a818 688 echo >&2 "Unknown error."
73848362 689 exit 100
cd445739
AM
690}
691
f6711e2a 692init_builder() {
cd445739 693 if [ -n "$DEBUG" ]; then
518ff1fb
ER
694 set -x
695 set -v
0dd6320d 696 fi
cd445739 697
4aeb9973 698 if [ "$NOINIT" != "yes" ] ; then
9c909460 699 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
b7cc0c94 700
09bf17c9 701 local macros_ver=$(rpm -E %?rpm_build_macros)
b7cc0c94
ER
702 if [ -z "$macros_ver" ]; then
703 REPO_DIR=$TOP_DIR/packages
704 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
705 else
706 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
707 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
708 exit 1
709 fi
710 REPO_DIR=$TOP_DIR
711 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
712 fi
29e90b02 713 else
9c909460
AM
714 REPO_DIR="."
715 PACKAGE_DIR="."
29e90b02 716 fi
cd445739 717
a8c9a155 718 __PWD=$(pwd)
00fcec7e 719}
720
f6711e2a 721get_spec() {
c890b916 722
2e5be021 723 update_shell_title "get_spec"
c890b916 724
cd445739 725 if [ -n "$DEBUG" ]; then
518ff1fb
ER
726 set -x
727 set -v
cd445739
AM
728 fi
729
9c909460
AM
730 cd "$REPO_DIR"
731 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
6277f15f
ER
732 # XXX: still needed?
733 SPECFILE=$(basename $SPECFILE)
cd445739 734 fi
cd445739 735
1ef6f5de 736 if [ "$NOCVSSPEC" != "yes" ]; then
049ab214
ER
737 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
738 echo "Warning: No CVS access defined - using local .spec file"
739 NOCVSSPEC="yes"
cd445739
AM
740 fi
741
1ef6f5de 742 if [ -d "$ASSUMED_NAME" -a -s "$ASSUMED_NAME/CVS/Root" ]; then
9c909460 743 cvsup "$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
703b6deb 744 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
1a135961 745 if [ ! -r "$ASSUMED_NAME/$SPECFILE" ]; then
746 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
747 exit 101
703b6deb
ER
748 fi
749 if [ ! -s "$ASSUMED_NAME/CVS/Root" ]; then
750 cvsup -a $ASSUMED_NAME || Exit_error err_cvs_add_failed
751 fi
752 cvsup -a "$ASSUMED_NAME/$SPECFILE" || Exit_error err_cvs_add_failed
9c909460 753 else
1ef6f5de
ER
754 cvsup -c -d $ASSUMED_NAME "packages/$ASSUMED_NAME/$SPECFILE" || {
755 # softfail if new package, i.e not yet added to cvs
756 [ ! -f "$ASSUMED_NAME/$SPECFILE" ] && Exit_error err_no_spec_in_repo
757 echo "Warning: package not in CVS - assuming new package"
758 NOCVSSPEC="yes"
759 NOCVS="yes"
760 }
f123bcb5
ER
761
762 # remove Entries.Static -- so 'cvs up' would update all files in a repo
1ef6f5de 763 rm -f "$ASSUMED_NAME/CVS/Entries.Static"
703b6deb 764 fi
0c3beb90 765
703b6deb
ER
766 cvsignore_df .cvsignore
767
768 # add default log format to .cvsignore if it is relative to package dir
769 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
770 # substitute known "macros" to glob
771 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\),*,g')
772 if [ "$logfile" ]; then
773 cvsignore_df "$logfile"
daeab113 774 fi
9c909460 775 fi
703b6deb
ER
776
777 # create symlinks for tools
778 if [ "$SYMLINK_TOOLS" != "no" ]; then
779 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
780 [ -f $a ] || continue
781 ln -sf ../$a $ASSUMED_NAME
782 cvsignore_df $a
783 done
784 fi
cd445739 785 fi
049ab214 786
9c909460 787 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
518ff1fb 788 Exit_error err_no_spec_in_repo
cd445739
AM
789 fi
790
791 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
9c909460 792 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
cd445739
AM
793 fi
794 unset OPTIONS
9c909460 795 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
7e40520f 796
ce40491a 797 set_spec_target
cd445739
AM
798}
799
f6711e2a 800find_mirror() {
9c909460 801 cd "$REPO_DIR"
782518da 802 local url="$1"
cd445739 803 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
939f2c12 804 $CVS_COMMAND update mirrors >&2
cd445739
AM
805 fi
806
807 IFS="|"
782518da
ER
808 local origin mirror name rest ol prefix
809 while read origin mirror name rest; do
810 # skip comments and empty lines
2faa4c32 811 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
782518da
ER
812 continue
813 fi
a8c9a155
ER
814 ol=$(echo -n "$origin" | wc -c)
815 prefix=$(echo -n "$url" | head -c $ol)
cd445739 816 if [ "$prefix" = "$origin" ] ; then
a8c9a155 817 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
818 echo -n "$mirror$suffix"
819 return 0
820 fi
821 done < mirrors
822 echo "$url"
823}
824
e7e0d4ec 825# Warning: unpredictable results if same URL used twice
f6711e2a 826src_no() {
9c909460 827 cd $PACKAGE_DIR
cd445739
AM
828 rpm_dump | \
829 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
830 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
831 head -n 1 | xargs
1471f6d6 832}
833
f6711e2a 834src_md5() {
e7e0d4ec 835 [ "$NO5" = "yes" ] && return
cd445739
AM
836 no=$(src_no "$1")
837 [ -z "$no" ] && return
9c909460 838 cd $PACKAGE_DIR
e7e0d4ec
ER
839 local md5
840
841 if [ -f additional-md5sums ]; then
842 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
843 if [ -z "$spec_rev" ]; then
a8c9a155 844 spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
e7e0d4ec
ER
845 fi
846 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
847 md5=$(grep -s -v '^#' additional-md5sums | \
848 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
849 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
850 grep -E '^[0-9a-f]{32}$')
851
852 if [ "$md5" ]; then
853 if [ $(echo "$md5" | wc -l) != 1 ] ; then
854 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
855 fi
856 echo "$md5" | tail -n 1
857 return
858 fi
cd445739 859 fi
e7e0d4ec 860
657d488b 861 source_md5=`grep -i "^#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
e7e0d4ec
ER
862 if [ -n "$source_md5" ]; then
863 echo $source_md5
cd445739 864 else
7805dcb4
PZ
865 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
866 if [ -n "$source_md5" ]; then
867 echo $source_md5
868 else
869 # we have empty SourceX-md5, but it is still possible
870 # that we have NoSourceX-md5 AND NoSource: X
657d488b 871 nosource_md5=`grep -i "^#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
7805dcb4
PZ
872 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
873 echo $nosource_md5
874 fi
cd445739 875 fi
cd445739
AM
876 fi
877}
878
f6711e2a 879distfiles_path() {
06541433
JR
880 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
881}
882
f6711e2a 883distfiles_url() {
06541433 884 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
885}
886
f6711e2a 887distfiles_attic_url() {
06541433 888 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
889}
890
f6711e2a 891good_md5() {
cd445739
AM
892 md5=$(src_md5 "$1")
893 [ "$md5" = "" ] || \
894 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
895}
896
f6711e2a 897good_size() {
a8c9a155 898 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 899 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
900}
901
f6711e2a 902cvsignore_df() {
947025e5 903 if [ "$CVSIGNORE_DF" != "yes" ]; then
904 return
905 fi
9c909460 906 cvsignore=${PACKAGE_DIR}/.cvsignore
7dc8d095
ER
907
908 # add only if not yet there
aa189b05 909 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
947025e5 910 echo "$1" >> $cvsignore
911 fi
912}
913
f6711e2a 914cvsup() {
ce40491a 915 update_shell_title "cvsup"
703b6deb 916 local OPTIONS="" ACTION="up"
9c909460 917
703b6deb 918 # checkout
9c909460 919 if [ "$1" = "-c" ]; then
703b6deb
ER
920 ACTION="co"
921 shift
922 fi
923 # add
924 if [ "$1" = "-a" ]; then
925 ACTION="add"
9c909460
AM
926 shift
927 fi
703b6deb
ER
928
929 OPTIONS="$ACTION "
930
ce40491a
ER
931 if [ -n "$CVSROOT" ]; then
932 OPTIONS="-d $CVSROOT $OPTIONS"
933 fi
b1c6aace 934
703b6deb
ER
935 if [ "$ACTION" != "add" ]; then
936 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
937 OPTIONS="$OPTIONS -A"
938 else
939 if [ -n "$CVSDATE" ]; then
940 OPTIONS="$OPTIONS -D $CVSDATE"
941 fi
942 if [ -n "$CVSTAG" ]; then
943 # FIXME: cvs add actually works with -r ?
944 OPTIONS="$OPTIONS -r $CVSTAG"
945 fi
ce40491a
ER
946 fi
947 fi
e7fa3b9f 948
ce40491a
ER
949 local result=1
950 local retries_counter=0
951 if [ $# = 1 ]; then
952 update_shell_title "cvsup: $*"
953 else
954 update_shell_title "cvsup: $# files"
955 fi
956 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
957 retries_counter=$(( $retries_counter + 1 ))
939f2c12 958 output=$(LC_ALL=C $CVS_COMMAND $OPTIONS "$@" 2>&1)
ce40491a
ER
959 result=$?
960 [ -n "$output" ] && echo "$output"
703b6deb
ER
961 if echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)" \
962 && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
ce40491a
ER
963 echo "Trying again [$*]... ($retries_counter)"
964 update_shell_title "cvsup: retry #$retries_counter"
965 sleep 2
966 continue
967 else
968 break
969 fi
970 done
971 update_shell_title "cvsup: done!"
972 return $result
e7fa3b9f
ER
973}
974
71f8e908 975# returns true if "$1" is ftp, http or https protocol url
f6711e2a 976is_url() {
71f8e908
ER
977 case "$1" in
978 ftp://*|http://*|https://*)
979 return 0
980 ;;
981 esac
982 return 1
983}
984
f6711e2a 985update_md5() {
ecba6ad5
ER
986 if [ $# -eq 0 ]; then
987 return
988 fi
989
990 update_shell_title "update md5"
991 if [ -n "$DEBUG" ]; then
518ff1fb
ER
992 set -x
993 set -v
ecba6ad5
ER
994 fi
995
9c909460 996 cd "$PACKAGE_DIR"
ecba6ad5
ER
997
998 # pass 1: check files to be fetched
999 local todo
1000 local need_files
1001 for i in "$@"; do
1002 local fp=$(nourl "$i")
1003 local srcno=$(src_no "$i")
6392b5fd
ER
1004 if [ -n "$ADD5" ]; then
1005 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
9c909460
AM
1006 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
1007 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 1008 else
9c909460 1009 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
1010 fi
1011 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1012 need_files="$need_files $i"
1013 fi
1014 done
1015
1016 # pass 1a: get needed files
1017 if [ "$need_files" ]; then
1018 get_files $need_files
1019 fi
1020
1021 # pass 2: proceed with md5 adding or updating
1022 for i in "$@"; do
1023 local fp=$(nourl "$i")
1024 local srcno=$(src_no "$i")
9c909460 1025 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 1026 if [ -z "$md5" ]; then
9c909460 1027 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 1028 fi
71f8e908 1029 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
6c1b2e7d 1030 local tag="# Source$srcno-md5:\t"
71f8e908 1031 if [[ "$md5" == *NoSource* ]]; then
6c1b2e7d
PZ
1032 tag="# NoSource$srcno-md5:\t"
1033 elif [ -n "$USEDIGEST" ]; then
1034 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 1035 fi
ecba6ad5 1036 md5=$(md5sum "$fp" | cut -f1 -d' ')
15bf3e99 1037 echo "Updating Source$srcno ($md5: $fp)."
ecba6ad5 1038 perl -i -ne '
6c1b2e7d
PZ
1039 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1040 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5 1041 ' \
9c909460 1042 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
1043 fi
1044 done
1045}
1046
f6711e2a 1047check_md5() {
60499e54 1048 local bad
3fbff8b8
ER
1049 [ "$NO5" = "yes" ] && return
1050
ecba6ad5
ER
1051 update_shell_title "check md5"
1052
1053 for i in "$@"; do
60499e54
AM
1054 bad=0
1055 if ! good_md5 "$i"; then
1056 echo -n "MD5 sum mismatch."
1057 bad=1
1058 fi
1059 if ! good_size "$i"; then
1060 echo -n "0 sized file."
1061 bad=1
ecba6ad5
ER
1062 fi
1063
60499e54
AM
1064 if [ $bad -eq 1 ]; then
1065 echo " Use -U to refetch sources,"
1066 echo "or -5 to update md5 sums, if you're sure files are correct."
1067 Exit_error err_no_source_in_repo $i
1068 fi
ecba6ad5
ER
1069 done
1070}
1071
f6711e2a 1072get_files() {
7cb24972 1073 update_shell_title "get_files"
cd445739
AM
1074
1075 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1076 set -x
1077 set -v
cd445739
AM
1078 fi
1079
f09c0772 1080 if [ $# -gt 0 ]; then
9c909460 1081 cd "$PACKAGE_DIR"
cd445739 1082
b1c6aace 1083 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 1084 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
1085 NOCVS="yes"
1086 fi
1087
f2e42a41 1088 local nc=0
e7fa3b9f 1089 local get_files_cvs=""
3815b69a 1090 for i in "$@"; do
f2e42a41 1091 nc=$((nc + 1))
dcebdffb 1092 local cvsup=0
3815b69a 1093 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 1094 update_shell_title "$i"
f09c0772 1095 local fp=`nourl "$i"`
ecba6ad5 1096 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 1097 continue
18e5347d 1098 fi
ecba6ad5 1099
cd445739 1100 FROM_DISTFILES=0
e7e0d4ec 1101 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1102
1103 # we know if source/patch is present in cvs/distfiles
1104 # - has md5 (in distfiles)
1105 # - in cvs... ideas?
1106
1107 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1108 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1109 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1110 echo "Warning: no URL given for $i"
1111 fi
08908161 1112 target="$fp"
cd445739 1113
e7e0d4ec 1114 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1115 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1116 echo "$fp having proper md5sum already exists"
cd445739
AM
1117 continue
1118 fi
28b34560 1119
bc10f694 1120 # optionally prefer mirror over distfiles if there's mirror
28b34560 1121 # TODO: build url list and then try each url from the list
bc10f694 1122 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1123 url="$im"
1124 else
1125 url=$(distfiles_url "$i")
1126 fi
1127
cd445739
AM
1128 url_attic=$(distfiles_attic_url "$i")
1129 FROM_DISTFILES=1
ecba6ad5
ER
1130 # is $url local file?
1131 if [[ "$url" = [./]* ]]; then
18a52930 1132 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1133 ${GETLOCAL} $url $target
1134 else
1135 if [ -z "$NOMIRRORS" ]; then
9e9f8920 1136 url=$(find_mirror "$url")
cd445739 1137 fi
9e9f8920
ER
1138
1139 local uri=${url}
1140 # make shorter message for distfiles urls
1141 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1142 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1143 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1144 uri="df: $uri"
1145 fi
1146 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1147 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1148 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1149 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1150 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1151 fi
1152 fi
ecba6ad5
ER
1153
1154 # is it empty file?
1155 if [ ! -s "$target" ]; then
cd445739
AM
1156 rm -f "$target"
1157 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1158 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1159 ${GETLOCAL} $url_attic $target
1160 else
1161 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1162 url_attic=$(find_mirror "$url_attic")
cd445739 1163 fi
18a52930 1164 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1165 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1166 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1167 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1168 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739 1169 fi
1cd7fc57 1170 test -s "$target" || rm -f "$target"
cd445739
AM
1171 fi
1172 fi
ecba6ad5
ER
1173
1174 if [ -s "$target" ]; then
947025e5 1175 cvsignore_df $target
1176 else
cd445739
AM
1177 rm -f "$target"
1178 FROM_DISTFILES=0
1179 fi
e7e0d4ec 1180 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
1181 if [ $# -gt 1 ]; then
1182 get_files_cvs="$get_files_cvs $fp"
1183 update_shell_title "$fp (will cvs up later)"
1184 cvsup=1
1185 else
1186 cvsup $fp
1187 fi
cd445739
AM
1188 fi
1189
f09c0772 1190 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1191 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1192 im=$(find_mirror "$i")
cd445739
AM
1193 else
1194 im="$i"
1195 fi
ce40491a 1196 update_shell_title "${GETURI%% *}: $im"
08908161 1197 ${GETURI} "$im" ${OUTFILEOPT} "$target" || \
33da77c4 1198 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1199 update_shell_title "${GETURI2%% *}: $im"
08908161 1200 ${GETURI2} "$im" ${OUTFILEOPT} "$target"
7e365483 1201 fi
1cd7fc57 1202 test -s "$target" || rm -f "$target"
cd445739
AM
1203 fi
1204
dcebdffb
ER
1205 if [ "$cvsup" = 1 ]; then
1206 continue
1207 fi
1208
cd445739 1209 fi
ecba6ad5
ER
1210
1211 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1212 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cdbd30e8 1213 if [ -n "GREEDSRC" ]; then
1214 get_greed_sources $i
1215 else
1216 Exit_error err_no_source_in_repo $i
1217 fi
cd445739 1218 fi
2a5f078d 1219
ecba6ad5 1220 # we check md5 here just only to refetch immediately
a4b50627 1221 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1222 :
1223 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1224 # wrong md5 from distfiles: remove the file and try again
cd445739 1225 # but only once ...
deccc50e 1226 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1227 FROM_DISTFILES=2
1228 rm -f $target
18a52930 1229 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1230 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1231 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1232 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1233 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1234 fi
ecba6ad5 1235 if [ ! -s "$target" ]; then
cd445739 1236 rm -f "$target"
18a52930 1237 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1238 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1239 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1240 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1241 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1242 fi
1243 fi
1244 test -s "$target" || rm -f "$target"
1245 fi
cd445739 1246 done
e7fa3b9f
ER
1247 SHELL_TITLE_PREFIX=""
1248
1249 if [ "$get_files_cvs" ]; then
ce40491a 1250 cvsup $get_files_cvs
e7fa3b9f 1251 fi
cd445739
AM
1252
1253 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1254 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1255 if [ -n "$CHMOD_FILES" ]; then
1256 chmod $CHMOD_MODE $CHMOD_FILES
1257 fi
1258 fi
cd445739
AM
1259 fi
1260}
1261
1262make_tagver() {
ce40491a 1263 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1264 set -x
1265 set -v
ce40491a 1266 fi
78eab2a1 1267
ce40491a
ER
1268 # Check whether first character of PACKAGE_NAME is legal for tag name
1269 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1270 TAG_PREFIX=tag_
1271 fi
d712cc12
ER
1272
1273 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1274 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1275
ce40491a
ER
1276 # Remove #kernel.version_release from TAGVER because tagging sources
1277 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1278 # besides, %{_kernel_ver_str} is not expanded.
1279
1280 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1281 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1282
1283 TAGVER=${TAGVER%#*}
ce40491a 1284 echo -n "$TAGVER"
cd445739
AM
1285}
1286
c713aac3
AG
1287# bool is_tag_a_branch(tag)
1288#
1289# returns 1 if a tag is a branch set on SPECFILE
1290is_tag_a_branch() {
1291 if [ -n "$DEBUG" ]; then
1292 set -x
1293 set -v
1294 fi
1295
1296 if [ $# -ne 1 ]; then
1297 return 0;
1298 fi
1299
1300 TAG=$1
f5141bbc 1301
9c909460 1302 cd "$PACKAGE_DIR"
939f2c12 1303 $CVS_COMMAND status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
c713aac3
AG
1304 return $?
1305}
1306
f6711e2a 1307tag_files() {
cd445739
AM
1308 TAG_FILES="$@"
1309
1310 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1311 set -x
1312 set -v
cd445739
AM
1313 fi
1314
73ef63d8
ER
1315 echo "Version: $PACKAGE_VERSION"
1316 echo "Release: $PACKAGE_RELEASE"
cd445739 1317
a18a9761 1318 local TAGVER
73ef63d8 1319 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1320 TAGVER=`make_tagver`
73ef63d8
ER
1321 echo "CVS tag: $TAGVER"
1322 fi
1323 if [ -n "$TAG" ]; then
1324 echo "CVS tag: $TAG"
1325 fi
cd445739 1326
39dcc7de 1327 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1328 if [ -n "$CVSROOT" ]; then
1329 OPTIONS="-d $CVSROOT $OPTIONS"
1330 fi
cd445739 1331
c713aac3
AG
1332 # if a tagname we are about to set already exists
1333 # and happens to be a branch (common case with AC-branch)
1334 # pass -B (allows -F to disturb branch tag)
1335 local _tag=$TAG
1336 if [ "$TAG_VERSION" = "yes" ]; then
1337 _tag=$TAGVER
1338 fi;
1339 is_tag_a_branch $_tag
28c23a72 1340 if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
c713aac3
AG
1341 OPTIONS="$OPTIONS -B"
1342 fi;
1343
9c909460 1344 cd "$PACKAGE_DIR"
73ef63d8
ER
1345 local tag_files
1346 for i in $TAG_FILES; do
1347 # don't tag files stored on distfiles
1348 [ -n "`src_md5 $i`" ] && continue
1349 local fp=`nourl "$i"`
1350 if [ -f "$fp" ]; then
1351 tag_files="$tag_files $fp"
cdbd30e8 1352 elif [ -n "GREEDSRC" ]; then
1353 get_greed_sources $i
73ef63d8
ER
1354 else
1355 Exit_error err_no_source_in_repo $i
03db3356 1356 fi
73ef63d8 1357 done
03db3356 1358
73ef63d8 1359 if [ "$tag_files" ]; then
cd445739 1360 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8 1361 update_shell_title "tag sources: $TAGVER"
19ca62ef 1362 printf "Tagging %d files\n" $(echo $tag_files | wc -w)
939f2c12 1363 $CVS_COMMAND $OPTIONS $TAGVER $tag_files || exit
cd445739
AM
1364 fi
1365 if [ -n "$TAG" ]; then
73ef63d8 1366 update_shell_title "tag sources: $TAG"
c4ff623e
ER
1367
1368 while [ "$tag_files" ]; do
1369 local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
1370 printf "Tagging %d files\n" $(echo $chunk | wc -w)
939f2c12 1371 $CVS_COMMAND $OPTIONS $TAG $chunk || exit
c4ff623e
ER
1372 tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
1373 done
cd445739 1374 fi
73ef63d8
ER
1375 fi
1376
9c909460 1377 cd "$PACKAGE_DIR"
73ef63d8
ER
1378 if [ "$TAG_VERSION" = "yes" ]; then
1379 update_shell_title "tag spec: $TAGVER"
939f2c12 1380 $CVS_COMMAND $OPTIONS $TAGVER $SPECFILE || exit
73ef63d8
ER
1381 fi
1382 if [ -n "$TAG" ]; then
1383 update_shell_title "tag spec: $TAG"
939f2c12 1384 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
73ef63d8 1385 fi
cd445739
AM
1386}
1387
f6711e2a 1388branch_files() {
cd445739
AM
1389 TAG=$1
1390 echo "CVS branch tag: $TAG"
518ff1fb 1391 shift
cd445739
AM
1392
1393 TAG_FILES="$@"
1394
1395 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1396 set -x
1397 set -v
cd445739
AM
1398 fi
1399
78a5a506 1400 local OPTIONS="tag $CVS_FORCE -b"
ec6b5dfc
AG
1401
1402 # branch exists?
1403 is_tag_a_branch $TAG
1404 if [ $? -eq 1 ]; then
1405 OPTIONS="$OPTIONS -B"
1406 fi
1407
78a5a506
ER
1408 if [ -n "$CVSROOT" ]; then
1409 OPTIONS="-d $CVSROOT $OPTIONS"
1410 fi
9c909460 1411 cd "$PACKAGE_DIR"
78a5a506
ER
1412 local tag_files
1413 for i in $TAG_FILES; do
1414 local fp=`nourl "$i"`
1415 if [ -f "$fp" ]; then
1416 tag_files="$tag_files $fp"
cdbd30e8 1417 elif [ -n "GREEDSRC" ]; then
1418 get_greed_sources $i
78a5a506
ER
1419 else
1420 Exit_error err_no_source_in_repo $i
c10fa4fa 1421 fi
78a5a506
ER
1422 done
1423 if [ "$tag_files" ]; then
939f2c12 1424 $CVS_COMMAND $OPTIONS $TAG $tag_files || exit
78a5a506 1425 fi
c10fa4fa 1426
9c909460 1427 cd "$PACKAGE_DIR"
939f2c12 1428 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
cd445739
AM
1429}
1430
1431
3009b80d
ER
1432# this function should exit early if package can't be built for this arch
1433# this avoids unneccessary BR filling.
1434check_buildarch() {
1435 local out ret
13c3c336 1436 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1437 ret=$?
1438 if [ $ret -ne 0 ]; then
1439 echo >&2 "$out"
1440 exit $ret
1441 fi
1442}
1443
9d99a240
ER
1444# from relup.sh
1445set_release() {
1446 local specfile="$1"
1447 local rel="$2"
1448 local newrel="$3"
1449 sed -i -e "
1450 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1451 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1452 " $specfile
1453}
1454
1455set_version() {
1456 local specfile="$1"
bc8502e6
ER
1457 local ver="$2" subver=$ver
1458 local newver="$3" newsubver=$newver
1459
1460 # try handling subver, everything that's not numeric-dotted in version
1461 if grep -Eq '%define\s+subver' $specfile; then
1462 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1463 ver=${ver%$subver}
1464 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1465 newver=${newver%$newsubver}
1466 fi
9d99a240
ER
1467 sed -i -e "
1468 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
bc8502e6 1469 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
9d99a240
ER
1470 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1471 " $specfile
1472}
1473
cacef28c 1474try_upgrade() {
cd445739 1475 if [ -n "$TRY_UPGRADE" ]; then
9d99a240 1476 local TNOTIFY TNEWVER TOLDVER
ce40491a 1477 update_shell_title "build_package: try_upgrade"
9d99a240 1478
cacef28c 1479 cd "$PACKAGE_DIR"
1480
0907f1eb
ER
1481 if [ "$UPGRADE_VERSION" ]; then
1482 TNEWVER=$UPGRADE_VERSION
cd445739 1483 else
0907f1eb
ER
1484 if [ -n "$FLOAT_VERSION" ]; then
1485 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1486 else
1487 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1488 fi
cd445739 1489
b9bef5ce
ER
1490 # pldnotify.awk does not set exit codes, but it has match for ERROR
1491 # in output which means so.
1492 if [[ "$TNOTIFY" = *ERROR* ]]; then
1493 echo >&2 "$TNOTIFY"
1494 exit 1
1495 fi
1496
0907f1eb
ER
1497 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1498 fi
cd445739
AM
1499
1500 if [ -n "$TNEWVER" ]; then
1501 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
9d99a240 1502 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
257af81b
ER
1503 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1504 cp -f $SPECFILE $SPECFILE.bak
1505 fi
cd445739 1506 chmod +w $SPECFILE
cacef28c 1507 set_release $SPECFILE $PACKAGE_RELEASE 1
9d99a240 1508 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
518ff1fb 1509 parse_spec
6decb793
ER
1510 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1511 echo >&2 "Upgrading version failed, you need to update spec yourself"
1512 exit 1
1513 fi
cacef28c 1514 return 1
cd445739
AM
1515 fi
1516 fi
cacef28c 1517 return 0
1518}
1519
1520build_package() {
1521 update_shell_title "build_package"
1522 if [ -n "$DEBUG" ]; then
1523 set -x
1524 set -v
1525 fi
1526
9c909460 1527 cd "$PACKAGE_DIR"
2a5f078d 1528
cd445739
AM
1529 case "$COMMAND" in
1530 build )
1531 BUILD_SWITCH="-ba" ;;
1532 build-binary )
1533 BUILD_SWITCH="-bb" ;;
1534 build-source )
1535 BUILD_SWITCH="-bs --nodeps" ;;
1536 build-prep )
1537 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1538 build-build )
1539 BUILD_SWITCH="-bc" ;;
1540 build-install )
1541 BUILD_SWITCH="-bi" ;;
1542 build-list )
1543 BUILD_SWITCH="-bl" ;;
1544
cd445739 1545 esac
c890b916 1546
2e5be021 1547 update_shell_title "build_package: $COMMAND"
cd445739
AM
1548 if [ -n "$LOGFILE" ]; then
1549 LOG=`eval echo $LOGFILE`
1550 if [ -d "$LOG" ]; then
1551 echo "Log file $LOG is a directory."
1552 echo "Parse error in the spec?"
518ff1fb 1553 Exit_error err_build_fail
cd445739
AM
1554 fi
1555 if [ -n "$LASTLOG_FILE" ]; then
1556 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1557 fi
525bf240
ER
1558 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
1559
9c909460 1560 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1561 RETVAL=`cat $RES_FILE`
1562 rm $RES_FILE
1563 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1564 if [ "$RETVAL" -eq "0" ]; then
1565 mv $LOG $LOGDIROK
1566 else
1567 mv $LOG $LOGDIRFAIL
1568 fi
1569 fi
8ba5cdda 1570 else
9c909460 1571 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
cd445739 1572 RETVAL=$?
8ba5cdda 1573 fi
cd445739
AM
1574 if [ "$RETVAL" -ne "0" ]; then
1575 if [ -n "$TRY_UPGRADE" ]; then
cacef28c 1576 echo "\nUpgrade package to new version failed."
257af81b 1577 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
cacef28c 1578 echo "Restoring old spec file."
257af81b
ER
1579 mv -f $SPECFILE.bak $SPECFILE
1580 fi
cacef28c 1581 echo ""
cd445739 1582 fi
518ff1fb 1583 Exit_error err_build_fail
cd445739
AM
1584 fi
1585 unset BUILD_SWITCH
1586}
1587
f6711e2a 1588nourl() {
cd445739
AM
1589 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1590}
1591
f6711e2a 1592install_required_packages() {
cd445739
AM
1593 run_poldek -vi $1
1594 return $?
1595}
1596
f6711e2a 1597find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1598 local SPEC="$1"
fa4bf1df
ER
1599 awk -F"\n" '
1600 /^%changelog/ { exit }
fa4bf1df
ER
1601 /^%bcond_with/{
1602 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1603 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1604 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1605 print bcond
1606 }' $SPEC | LC_ALL=C sort -u
1607}
1608
117d9861 1609process_bcondrc() {
301cbfd4
ER
1610 # expand bconds from ~/.bcondrc
1611 # The file structure is like gentoo's package.use:
1612 # ---
1613 # * -selinux
1614 # samba -mysql -pgsql
47a8df12 1615 # w32codec-installer license_agreement
301cbfd4
ER
1616 # php +mysqli
1617 # ---
fa4bf1df 1618 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1619 :
1620 else
1621 return
1622 fi
301cbfd4 1623
117d9861 1624 SN=${SPECFILE%%\.spec}
c8a3e2ac 1625
117d9861
ER
1626 local bcondrc=$HOME/.bcondrc
1627 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1628
117d9861 1629 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1630
117d9861
ER
1631 while read pkg flags; do
1632 # ignore comments
1633 [[ "$pkg" == \#* ]] && continue
1634
1635 # any package or current package?
1636 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1637 for flag in $flags; do
1638 local opt=${flag#[+-]}
1639
1640 # use only flags which are in this package.
1641 if [[ $bcond_avail = *${opt}* ]]; then
1642 if [[ $flag = -* ]]; then
1643 if [[ $BCOND != *--with?${opt}* ]]; then
1644 BCOND="$BCOND --without $opt"
1645 fi
1646 else
1647 if [[ $BCOND != *--without?${opt}* ]]; then
1648 BCOND="$BCOND --with $opt"
301cbfd4
ER
1649 fi
1650 fi
117d9861
ER
1651 fi
1652 done
1653 fi
1654 done < $bcondrc
1655 update_shell_title "parse ~/.bcondrc: DONE!"
1656}
1657
8ff97f39 1658set_bconds_values() {
117d9861
ER
1659 update_shell_title "set bcond values"
1660
1661 AVAIL_BCONDS_WITHOUT=""
1662 AVAIL_BCONDS_WITH=""
8ff97f39 1663
5a28189c 1664 if grep -Eq '^# *_with' ${SPECFILE}; then
8ff97f39
ER
1665 echo >&2 "ERROR: This spec has old style bconds."
1666 exit 1
1667 fi
1668
1669 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1670 return
301cbfd4
ER
1671 fi
1672
117d9861
ER
1673 local bcond_avail=$(find_spec_bcond $SPECFILE)
1674 process_bcondrc "$SPECFILE"
1675
fa4bf1df 1676 update_shell_title "parse bconds"
2a5f078d 1677
8ff97f39
ER
1678 local opt bcond
1679 for opt in $bcond_avail; do
1680 case "$opt" in
1681 without_*)
1682 bcond=${opt#without_}
10d92f71
ER
1683 case "$BCOND" in
1684 *--without?${bcond}*)
8ff97f39 1685 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
10d92f71
ER
1686 ;;
1687 *)
8ff97f39 1688 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
10d92f71
ER
1689 ;;
1690 esac
cd445739 1691 ;;
8ff97f39
ER
1692 with_*)
1693 bcond=${opt#with_}
10d92f71
ER
1694 case "$BCOND" in
1695 *--with?${bcond}*)
8ff97f39 1696 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
10d92f71
ER
1697 ;;
1698 *)
8ff97f39 1699 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
10d92f71
ER
1700 ;;
1701 esac
cd445739 1702 ;;
8ff97f39
ER
1703 *)
1704 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1705 exit 1
1706 ;;
1707 esac
1708 done
cd445739
AM
1709}
1710
f6711e2a 1711run_sub_builder() {
cd445739 1712 package_name="${1}"
af6b168f 1713 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1714 #
1715